
#ifndef __SOUND_EFFECTOR_H__
#define __SOUND_EFFECTOR_H__


#include "r_cg_macrodriver.h"
#include "sound_effector_userdef.h"

//`l


#define INBUF_SIZE (98304)				//2b, 384kB

#define BUF_RAM_START_ADDR 0x00800000	//g_inbug蓖ĂAhX
#define BUF_RAM_END_ADDR   0x0085FFFF

#define PCM_FS (48000)					//TvOg(48kHz)

//LED_Ńp^[
#define LED_OFF (0x0)
#define LED_ON (0xFFFFFFFF)
#define LED_BLINK (0xFF00FF00)
#define LED_BLINK1 (0xCCCCCCCC)
#define LED_BLINK2 (0x88000000)

//|[gfobO
#define P27 PORT2.PODR.BIT.B7

//typedef

//PCM\
typedef struct{
	short ch0;
	short ch1;
} pcm_data;

//O[oϐ

#if (OUT_CH == 2)
extern pcm_data g_outbuf[];
#elif (OUT_CH == 1)
extern short g_outbuf[];
#endif

extern  pcm_data g_inbuf[];

extern unsigned long g_outbuf_rp;
extern unsigned long g_outbuf_wp;

extern unsigned long g_inbuf_wp;

extern short g_rspi0_send_data;

#if (OUT_CH == 2)
extern pcm_data g_next_send_data;
extern pcm_data g_zero_data;
#elif (OUT_CH == 1)
extern short g_next_send_data;
extern short g_zero_data;
#endif

extern unsigned short g_rspi0_flag;

extern unsigned short g_sampling_period_flag;
extern unsigned long g_sampling_counter;

extern unsigned char g_sw_state;

extern unsigned short g_ad_flag;
extern unsigned short g_ad_val[];

#ifdef DEBUG

extern unsigned long g_rspi_null_data_count;

extern unsigned long g_err_led_patturn;
extern unsigned long g_err_led_index;

#endif

#ifdef DEBUG2

extern unsigned long g_rspi0_success_count;

extern unsigned long g_rspi0_error_count;

#endif

//֐vg^Cv

extern void sound_effector_init( void );
extern void sound_effector_start( void );

#if (OUT_CH == 2)
extern int put_data( pcm_data data );
extern pcm_data clipping_data_norm( float ch0_data, float ch1_data );
extern pcm_data clipping_data_raw( float ch0_data, float ch1_data );
#elif (OUT_CH == 1)
extern int put_data( short data );
extern short clipping_data_norm(float data);
extern short clipping_data_raw(float data);
#endif

extern unsigned long outbuf_spool_data_num(void);

#endif
